%bcond_with tex

Summary: GUI analysis for Ftrace data captured by trace-cmd
Name:    kernelshark
Version: 2.1.1
Release: 6%{?dist}
License: GPLv2 and LGPLv2
URL:     https://kernelshark.org
Source0: https://git.kernel.org/pub/scm/utils/trace-cmd/kernel-shark.git/snapshot/kernel-shark-kernelshark-v%{version}.tar.gz
Source1: %{name}.appdata.xml

BuildRequires: cmake  desktop-file-utils doxygen gcc gcc-c++ graphviz libappstream-glib
BuildRequires: pkgconf pkgconfig(glut) pkgconfig(json-c) pkgconfig(libxml-2.0) pkgconfig(Qt5Core)
BuildRequires: libtracecmd-devel libtraceevent-devel libtracefs-devel libtracecmd trace-cmd
BuildRequires: xmlto make chrpath freeglut-devel gnu-free-sans-fonts docbook-style-xsl
%if %{with tex}
BuildRequires: texlive-epstopdf
%endif
BuildRequires: ghostscript
Requires: polkit

%description
KernelShark is a front end reader of trace-cmd output. "trace-cmd record" and "trace-cmd extract"
create a trace.dat (trace-cmd.dat) file. kernelshark can read this file and produce a graph and list
view of its data. 

%prep
%autosetup -n kernel-shark-%{name}-v%{version}

%build
cd build
cmake ..  \
    -DCMAKE_BUILD_TYPE=Package \
    -D_INSTALL_PREFIX=%{_prefix} \
    -D_LIBDIR=%{_libdir} \
    -DCMAKE_C_FLAGS_PACKAGE="%{optflags}" \
    -DCMAKE_EXE_LINKER_FLAGS="%{build_ldflags}" \
    -D_DOXYGEN_DOC=1 \
    %{nil}

%if %{with tex}
make V=1 all doc
%endif

%install
cd build
make libdir=%{_libdir} prefix=%{_prefix} V=1 DESTDIR=%{buildroot}/  install

sed -i '/Version/d' %{buildroot}%{_datadir}/applications/kernelshark.desktop
desktop-file-validate %{buildroot}%{_datadir}/applications/kernelshark.desktop

install -Dp %{SOURCE1} %{buildroot}%{_metainfodir}/%{name}.appdata.xml
appstream-util validate-relax --nonet %{buildroot}%{_metainfodir}/%{name}.appdata.xml

find %{buildroot} -type f -perm 755 -name \*so\* -exec chrpath --delete {} \;
chrpath --delete %{buildroot}%{_bindir}/kernelshark
chrpath --delete %{buildroot}%{_bindir}/kshark-record

%files
%doc README
%{_bindir}/kernelshark
%{_bindir}/kshark-record
%{_bindir}/kshark-su-record
%dir %{_libdir}/kernelshark
%{_libdir}/kernelshark/*
%{_libdir}/libkshark-gui.so.2.1.1
%{_libdir}/libkshark-plot.so.2.1.1
%{_libdir}/libkshark.so
%{_libdir}/libkshark.so.2
%{_libdir}/libkshark.so.2.1.1
%{_libdir}/pkgconfig/libkshark.pc
%{_includedir}/%{name}
%{_datadir}/applications/kernelshark.desktop
%dir %{_datadir}/icons/kernelshark
%{_datadir}/icons/kernelshark/*
%{_datadir}/polkit-1/actions/org.freedesktop.kshark-record.policy
%{_metainfodir}/%{name}.appdata.xml

%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.1.1-6
- Rebuilt for OpenCloudOS Stream 23.09

* Mon Sep 04 2023 cunshunxia <cunshunxia@tencent.com> - 2.1.1-5
- Rebuilt for ghostscript 10.01.2

* Tue Aug 22 2023 Shuo Wang <abushwang@tencent.com> - 2.1.1-4
- Rebuilt for freeglut 3.4.0

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.1.1-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.1.1-2
- Rebuilt for OpenCloudOS Stream 23

* Thu Mar 30 2023 Shuo Wang <abushwang@tencent.com> - 2.1.1-1
- initial build
